/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplate{}

// WhatsAppTemplate struct for WhatsAppTemplate
type WhatsAppTemplate struct {
	// Available for gateways using CloudAPI only
	Id *string `json:"id,omitempty"`
	Status string `json:"status"`
	RejectedReason *string `json:"rejected_reason,omitempty"`
	Name string `json:"name"`
	Language string `json:"language"`
	Category WhatsAppTemplateCategory `json:"category"`
	Components []WhatsAppTemplateComponent `json:"components"`
	AllowCategoryChange bool `json:"allow_category_change"`
}

// NewWhatsAppTemplate instantiates a new WhatsAppTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplate(status string, name string, language string, category WhatsAppTemplateCategory, components []WhatsAppTemplateComponent, allowCategoryChange bool) *WhatsAppTemplate {
	this := WhatsAppTemplate{}
	this.Status = status
	this.Name = name
	this.Language = language
	this.Category = category
	this.Components = components
	this.AllowCategoryChange = allowCategoryChange
	return &this
}

// NewWhatsAppTemplateWithDefaults instantiates a new WhatsAppTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateWithDefaults() *WhatsAppTemplate {
	this := WhatsAppTemplate{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *WhatsAppTemplate) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *WhatsAppTemplate) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *WhatsAppTemplate) SetId(v string) {
	o.Id = &v
}

// GetStatus returns the Status field value
func (o *WhatsAppTemplate) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *WhatsAppTemplate) SetStatus(v string) {
	o.Status = v
}

// GetRejectedReason returns the RejectedReason field value if set, zero value otherwise.
func (o *WhatsAppTemplate) GetRejectedReason() string {
	if o == nil || IsNil(o.RejectedReason) {
		var ret string
		return ret
	}
	return *o.RejectedReason
}

// GetRejectedReasonOk returns a tuple with the RejectedReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetRejectedReasonOk() (*string, bool) {
	if o == nil || IsNil(o.RejectedReason) {
		return nil, false
	}
	return o.RejectedReason, true
}

// HasRejectedReason returns a boolean if a field has been set.
func (o *WhatsAppTemplate) HasRejectedReason() bool {
	if o != nil && !IsNil(o.RejectedReason) {
		return true
	}

	return false
}

// SetRejectedReason gets a reference to the given string and assigns it to the RejectedReason field.
func (o *WhatsAppTemplate) SetRejectedReason(v string) {
	o.RejectedReason = &v
}

// GetName returns the Name field value
func (o *WhatsAppTemplate) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *WhatsAppTemplate) SetName(v string) {
	o.Name = v
}

// GetLanguage returns the Language field value
func (o *WhatsAppTemplate) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *WhatsAppTemplate) SetLanguage(v string) {
	o.Language = v
}

// GetCategory returns the Category field value
func (o *WhatsAppTemplate) GetCategory() WhatsAppTemplateCategory {
	if o == nil {
		var ret WhatsAppTemplateCategory
		return ret
	}

	return o.Category
}

// GetCategoryOk returns a tuple with the Category field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetCategoryOk() (*WhatsAppTemplateCategory, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Category, true
}

// SetCategory sets field value
func (o *WhatsAppTemplate) SetCategory(v WhatsAppTemplateCategory) {
	o.Category = v
}

// GetComponents returns the Components field value
func (o *WhatsAppTemplate) GetComponents() []WhatsAppTemplateComponent {
	if o == nil {
		var ret []WhatsAppTemplateComponent
		return ret
	}

	return o.Components
}

// GetComponentsOk returns a tuple with the Components field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetComponentsOk() ([]WhatsAppTemplateComponent, bool) {
	if o == nil {
		return nil, false
	}
	return o.Components, true
}

// SetComponents sets field value
func (o *WhatsAppTemplate) SetComponents(v []WhatsAppTemplateComponent) {
	o.Components = v
}

// GetAllowCategoryChange returns the AllowCategoryChange field value
func (o *WhatsAppTemplate) GetAllowCategoryChange() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.AllowCategoryChange
}

// GetAllowCategoryChangeOk returns a tuple with the AllowCategoryChange field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplate) GetAllowCategoryChangeOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AllowCategoryChange, true
}

// SetAllowCategoryChange sets field value
func (o *WhatsAppTemplate) SetAllowCategoryChange(v bool) {
	o.AllowCategoryChange = v
}

func (o WhatsAppTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	toSerialize["status"] = o.Status
	if !IsNil(o.RejectedReason) {
		toSerialize["rejected_reason"] = o.RejectedReason
	}
	toSerialize["name"] = o.Name
	toSerialize["language"] = o.Language
	toSerialize["category"] = o.Category
	toSerialize["components"] = o.Components
	toSerialize["allow_category_change"] = o.AllowCategoryChange
	return toSerialize, nil
}

type NullableWhatsAppTemplate struct {
	value *WhatsAppTemplate
	isSet bool
}

func (v NullableWhatsAppTemplate) Get() *WhatsAppTemplate {
	return v.value
}

func (v *NullableWhatsAppTemplate) Set(val *WhatsAppTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplate(val *WhatsAppTemplate) *NullableWhatsAppTemplate {
	return &NullableWhatsAppTemplate{value: val, isSet: true}
}

func (v NullableWhatsAppTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


